n, q, k = map(int, input().split())
favorite_permutation = list(map(int, input().split()))
changes = []

# Создаем список задач и заполняем их приоритетами из любимой перестановки
tasks = [(i + 1, favorite_permutation[i]) for i in range(n)]

# Считываем интервалы изменений порядка задач
for _ in range(q):
    l, r = map(int, input().split())
    changes.append((l, r))

# Применяем изменения порядка выполнения задач
for l, r in changes:
    tasks[l - 1:r] = sorted(tasks[l - 1:r], key=lambda x: x[1])

# Определяем задачу, которая будет выполнена k-ой
result = tasks[k - 1][0]
print(result)
